%define kmodtool sh %{SOURCE49}
%define	kmod_name xenpv
# Note: if mock build fails(check root.log), 
# check version of rhel5 being used to build kernel modules 
# and replace the rev below with the one in the log file 
%define kverrel 2.6.18-53.1.21.0.1.el5

# hardcode for now 
%define kvariants ""
%define kbuilddep kernel-devel = %{kverrel}

%ifarch i686
%define kvariants "" PAE
%define kbuilddep kernel-devel = %{kverrel} kernel-PAE-devel = %{kverrel}
%endif

%define xen_src_rev 3.1.0 

Name: xenpv
License: GPL
Group: System/Kernel
Summary: xen paravirtual drivers for Linux Full-Virt/HVM guests
Version: 0.1
Release: 9%{?dist}
Source0: xen-%{xen_src_rev}-src.tgz
Source1: xenpv.modprobe
Source3: README.el5
Source49: %{name}-kmodtool-el5
ExclusiveArch:  i686 x86_64 ia64

# rhel-5 fixes
Patch1:  %name-buildfix.patch
Patch2:  %name-nosysfs.patch
Patch3:  %name-noxen.patch
Patch4:  %name-initrace.patch
# remove patch5 if rebase to xen-3.1.2
Patch5:  %name-smprace.patch
Patch6:  %name-skb-useafterfree.patch
Patch7:  %name-ia64-balloon.patch
Patch8:  %name-ia64-isairq.patch
Patch9:  %name-netfront-pae.patch
Patch14: %name-signal-guest-panic.patch
Patch15: %name-kzalloc-watch.patch
# remove patch18 if rebase to xen-3.1.2
Patch18: %name-evtchn-unbind.patch

# resource allocation bits
# Patch20:  %name-res-rtl8139.diff
# Patch21:  %name-res-piix.diff

# module autoloading
Patch30:  %name-autoload.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: %{name}-kmod
Provides: %{name}-kmod-common
BuildRequires: imake kernel %kbuilddep

%description
xen paravirtual drivers for Linux Full-Virt/HVM guests

%define kmp_version %{version}
%define kmp_release %{release}
%{expand:%(%{kmodtool} rpmtemplate_kmp xenpv %{kverrel} %{kvariants} 2>/dev/null)}

%prep
%setup -q -c

cd xen-%{xen_src_rev}-src

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch14 -p1
%patch15 -p1
%patch18 -p1

%patch30 -p1
set -- *
mkdir source
mv "$@" source/

%build
cd xen-%{xen_src_rev}-src
for flavor in %kvariants; do
	echo "### building for $flavor kernel ###"
	mdir="obj-$flavor/unmodified_drivers/linux-2.6"
	ksrc=%{_usrsrc}/kernels/%{kverrel}${flavor:+-$flavor}-%{_target_cpu}
	rm -rf obj-$flavor
	cp -r source obj-$flavor
	(cd $mdir; ./mkbuildtree)
	make %{?_smp_mflags} -C $ksrc M=$PWD/$mdir modules
done

%install
rm -rf %{buildroot}
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=extra/%{name}/%{version}-%{release}
cd xen-%{xen_src_rev}-src
for flavor in %kvariants; do
	mdir="obj-$flavor/unmodified_drivers/linux-2.6"
	ksrc=%{_usrsrc}/kernels/%{kverrel}${flavor:+-$flavor}-%{_target_cpu}
	make -C $ksrc M=$PWD/$mdir modules_install 
done
mkdir -p %{buildroot}/etc/modprobe.d
cp -v %{SOURCE1} %{buildroot}/etc/modprobe.d/xenpv
mkdir -p %{buildroot}/usr/share/doc/%{name}-%{version}-%{release}
cp -v %{SOURCE3} %{buildroot}/usr/share/doc/%{name}-%{version}-%{release}/README

#%files
#%defattr(-,root,root)
#%config(noreplace) /etc/modprobe.d/xenpv
#%doc /usr/share/doc/%{name}-%{version}-%{release}/README

%changelog
* Wed Sep 12 2007 Don Dutile <ddutile@dddesktop0.boston.redhat.com> - 0.1-1
- First version based on Gerd's -35 mercurial tree

